/* UUSHRED 3.2  by Mark Neidengard mneideng@cosmos.acs.calpoly.edu   7-1993
   Subject handling routines */

int subject_handle (string,sub_array,index,sub_switch)
char *string;
struct subject_line *sub_array;
int index;
struct switches *sub_switch;
{
int source_count=9,target_count=0;

while (string[source_count]) {
   if (string[source_count]==' ')
      if (string[source_count-1]==' ') {
         ++source_count;
         continue;
      }
   if (sub_switch->avoidance)
   if (string[source_count]=='Q')
      if (string[source_count-1]=='A')
         if (string[source_count-2]=='F')
            return 0;
   if (sub_switch->re_skip)
   if (string[source_count]==':')
      if (string[source_count-1]=='e')
         if (string[source_count-2]=='R')
            return 0;
   if (string[source_count] >= '0' && string[source_count] <= '9')
      if (string[source_count-1] < '0' || string[source_count-1] > '9')
      if (string[source_count+1] < '0' || string[source_count+1] > '9')
         sub_array[index].string[target_count++]='0';
   sub_array[index].string[target_count]=
      (string[source_count] >= 'A' && string[source_count] <= 'Z')?
      string[source_count]+32:string[source_count];
   ++source_count;++target_count;
   }
sub_array[index].string[target_count]='\0';
return 1;
}

swap (the_array,first,second)
struct subject_line the_array[];
int first,second;
{
   char temp[82];
   struct data_line *tmp;
      strcpy (temp,the_array[first].string);
      strcpy (the_array[first].string,the_array[second].string);
      strcpy (the_array[second].string,temp);
   tmp=the_array[first].index;
   the_array[first].index=the_array[second].index;
   the_array[second].index=tmp;
}

quicksort (subject_array,left,right)
struct subject_line subject_array[];
int left,right;
{
   char partition[82];
  int seek_right;
  int seek_left;

  if  (right>left) {
   seek_right=left-1;seek_left=right;
   strcpy (partition,subject_array[right].string);

   for (;;) {
      while (strcmp(subject_array[++seek_right].string,partition) < 0);
      while (strcmp(subject_array[--seek_left].string,partition) > 0);
      if (seek_right>=seek_left) break;
      swap (subject_array,seek_right,seek_left);
   }

   swap (subject_array,seek_right,right);
   quicksort (subject_array, left,seek_right-1);
   quicksort (subject_array, seek_right+1, right);
  }
}
